/**
 * markdown instance on github for `Document`
 * @desczh
 * `Document`的markdown实例
 *
 * 基于github
 * @file
 */
import { Document } from 'macoolka-document';
/**
 * # h1
 * @since 0.2.0
 */
export declare const h1: Document['h1'];
/**
 * ## h2
 * @since 0.2.0
 */
export declare const h2: Document['h2'];
/**
 * ### h3
 * @since 0.2.0
 */
export declare const h3: Document['h3'];
/**
 * #### h4
 * @since 0.2.0
 */
export declare const h4: Document['h4'];
/**
 * ##### h5
 * @since 0.2.0
 */
export declare const h5: Document['h5'];
/**
 * ###### h6
 * @since 0.2.0
 */
export declare const h6: Document['h6'];
/**
 * **bold**
 * @since 0.2.0
 */
export declare const bold: Document['bold'];
/**
 * *italic*
 * @since 0.2.0
 */
export declare const italic: Document['italic'];
/**
 * ~~del~~
 * @since 0.2.0
 */
export declare const del: Document['del'];
/**
 * 'q'
 * @since 0.2.0
 */
export declare const q: Document['q'];
/**
 * **cite**
 * @since 0.2.0
 */
export declare const cite: Document['cite'];
/**
 * **dfn**
 * @since 0.2.0
 */
export declare const dfn: Document['dfn'];
/**
 * **ins**
 * @since 0.2.0
 */
export declare const ins: Document['ins'];
/**
 * **mark**
 * @since 0.2.0
 */
export declare const mark: Document['mark'];
/**
 * **em**
 * @since 0.2.0
 */
export declare const em: Document['em'];
/**
 * 1. ol1
 * 1. ol2"
 * @since 0.2.0
 */
export declare const ol: Document['ol'];
/**
 * - ul1
 * - ul2"
 *
 *
 * @since 0.2.0
 */
export declare const ul: Document['ul'];
/**
 * article
 *
 *
 * @since 0.2.0
 */
export declare const article: Document['article'];
/**
 * p
 *
 *
 * @since 0.2.0
 */
export declare const p: Document['p'];
/**
 * br
 *
 * @since 0.2.0
 */
export declare const br: Document['br'];
/**
 * [link](/link)
 * @since 0.2.0
 */
export declare const link: Document['link'];
/**
 * ![img](https://cdn.pixabay.com/photo/2019/08/12/14/23/wedding-4401383_960_720.jpg)
 * @since 0.2.0
 */
export declare const img: Document['img'];
/**
 * ```ts
 *
 * import a from 'a'
 *
 * ```
 *
 *
 * @since 0.2.0
 */
export declare const code: Document['code'];
/**
 * ---
 *
 *
 * @since 0.2.0
 */
export declare const hr: Document['hr'];
/**
 * section
 *
 * @since 0.2.0
 */
export declare const section: Document['section'];
/**
 * > blockquote 1
 * > blockquote 2"
 *
 *
 * @since 0.2.0
 */
export declare const blockquote: Document['blockquote'];
/**
 * |  head1 | head2  |
 * |  --- | ---  |
 * |  11 | 12  |
 * |  21 | 22  |
 * @since 0.2.0
 */
export declare const table: Document['table'];
/**
 * markdown instance on github
 * @desczh
 * 基于github markdown
 */
export declare const markdown: Document;
