"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.markdown = exports.table = exports.blockquote = exports.section = exports.hr = exports.code = exports.img = exports.link = exports.br = exports.p = exports.article = exports.ul = exports.ol = exports.em = exports.mark = exports.ins = exports.dfn = exports.cite = exports.q = exports.del = exports.italic = exports.bold = exports.h6 = exports.h5 = exports.h4 = exports.h3 = exports.h2 = exports.h1 = void 0;
var Array_1 = require("fp-ts/Array");
var O = __importStar(require("fp-ts/Option"));
var pipeable_1 = require("fp-ts/pipeable");
var CRLF = '\n';
var NEWLINE = '\n\n';
var replaceKeys = function (a) { return a.replace(/\|/gi, "\\|"); };
/**
 * # h1
 * @since 0.2.0
 */
var h1 = function (title) { return "# ".concat(title); };
exports.h1 = h1;
/**
 * ## h2
 * @since 0.2.0
 */
var h2 = function (title) { return "## ".concat(title); };
exports.h2 = h2;
/**
 * ### h3
 * @since 0.2.0
 */
var h3 = function (title) { return "### ".concat(title); };
exports.h3 = h3;
/**
 * #### h4
 * @since 0.2.0
 */
var h4 = function (title) { return "#### ".concat(title); };
exports.h4 = h4;
/**
 * ##### h5
 * @since 0.2.0
 */
var h5 = function (title) { return "##### ".concat(title); };
exports.h5 = h5;
/**
 * ###### h6
 * @since 0.2.0
 */
var h6 = function (title) { return "###### ".concat(title); };
exports.h6 = h6;
/**
 * **bold**
 * @since 0.2.0
 */
var bold = function (text) { return "**".concat(text, "**"); };
exports.bold = bold;
/**
 * *italic*
 * @since 0.2.0
 */
var italic = function (text) { return "*".concat(text, "*"); };
exports.italic = italic;
/**
 * ~~del~~
 * @since 0.2.0
 */
var del = function (text) { return "~~".concat(text, "~~"); };
exports.del = del;
/**
 * 'q'
 * @since 0.2.0
 */
var q = function (text) { return "'".concat(text, "'"); };
exports.q = q;
/**
 * **cite**
 * @since 0.2.0
 */
var cite = function (text) { return "**".concat(text, "**"); };
exports.cite = cite;
/**
 * **dfn**
 * @since 0.2.0
 */
var dfn = function (text) { return "**".concat(text, "**"); };
exports.dfn = dfn;
/**
 * **ins**
 * @since 0.2.0
 */
var ins = function (text) { return "**".concat(text, "**"); };
exports.ins = ins;
/**
 * **mark**
 * @since 0.2.0
 */
var mark = function (text) { return "**".concat(text, "**"); };
exports.mark = mark;
/**
 * **em**
 * @since 0.2.0
 */
var em = function (text) { return "**".concat(text, "**"); };
exports.em = em;
/**
 * 1. ol1
 * 1. ol2"
 * @since 0.2.0
 */
var ol = function (as) { return as.map(function (a) { return "1. ".concat(a); }).join(CRLF) + NEWLINE; };
exports.ol = ol;
/**
 * - ul1
 * - ul2"
 *
 *
 * @since 0.2.0
 */
var ul = function (as) { return as.map(function (a) { return "- ".concat(a); }).join(CRLF) + NEWLINE; };
exports.ul = ul;
/**
 * article
 *
 *
 * @since 0.2.0
 */
var article = function (text) { return text + NEWLINE; };
exports.article = article;
/**
 * p
 *
 *
 * @since 0.2.0
 */
var p = function (text) { return text + NEWLINE; };
exports.p = p;
/**
 * br
 *
 * @since 0.2.0
 */
var br = function (text) { return text + CRLF; };
exports.br = br;
/**
 * [link](/link)
 * @since 0.2.0
 */
var link = function (text, href) { return "[".concat(text, "](").concat(href, ")"); };
exports.link = link;
/**
 * ![img](https://cdn.pixabay.com/photo/2019/08/12/14/23/wedding-4401383_960_720.jpg)
 * @since 0.2.0
 */
var img = function (text, href) { return "![".concat(text, "](").concat(href, ")"); };
exports.img = img;
/**
 * ```ts
 *
 * import a from 'a'
 *
 * ```
 *
 *
 * @since 0.2.0
 */
var code = function (language) { return function (a) { return "```".concat(language).concat(NEWLINE).concat(a).concat(NEWLINE, "```") + NEWLINE; }; };
exports.code = code;
/**
 * ---
 *
 *
 * @since 0.2.0
 */
var hr = function () { return '---' + NEWLINE; };
exports.hr = hr;
/**
 * section
 *
 * @since 0.2.0
 */
var section = function (text) { return text + NEWLINE; };
exports.section = section;
/**
 * > blockquote 1
 * > blockquote 2"
 *
 *
 * @since 0.2.0
 */
var blockquote = function (as) { return as.map(function (a) { return "> ".concat(a); }).join(CRLF) + NEWLINE; };
exports.blockquote = blockquote;
/**
 * |  head1 | head2  |
 * |  --- | ---  |
 * |  11 | 12  |
 * |  21 | 22  |
 * @since 0.2.0
 */
var table = function (as) {
    var header = (0, pipeable_1.pipe)((0, Array_1.head)(as), O.map(function (a) {
        return "".concat(CRLF, "| ").concat(a.map(replaceKeys).map(function (v) { return " ".concat(v.trim(), " "); }).join('|'), " |").concat(CRLF)
            + "| ".concat(a.map(function () { return ' --- '; }).join('|'), " |").concat(CRLF);
    }), O.getOrElse(function () { return ''; }));
    var body = (0, pipeable_1.pipe)((0, Array_1.tail)(as), O.map(function (row) {
        return row.map(function (a) {
            return "| ".concat(a.map(replaceKeys).map(function (v) { return " ".concat(v.trim(), " "); }).join("|"), " |");
        }).join(CRLF);
    }), O.getOrElse(function () { return ''; }));
    return header + body + CRLF;
};
exports.table = table;
/**
 * markdown instance on github
 * @desczh
 * 基于github markdown
 */
exports.markdown = {
    h1: exports.h1,
    h2: exports.h2,
    h3: exports.h3,
    h4: exports.h4,
    h5: exports.h5,
    h6: exports.h6,
    bold: exports.bold,
    italic: exports.italic,
    del: exports.del,
    q: exports.q,
    cite: exports.cite,
    dfn: exports.dfn,
    ins: exports.ins,
    mark: exports.mark,
    em: exports.em,
    ol: exports.ol,
    ul: exports.ul,
    article: exports.article,
    p: exports.p,
    br: exports.br,
    link: exports.link,
    img: exports.img,
    code: exports.code,
    hr: exports.hr,
    table: exports.table,
    section: exports.section,
    blockquote: exports.blockquote,
};
//# sourceMappingURL=markdown.js.map